﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.Globals;
@using Portal.Models.SupplierPerformance;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;

@Html.DevExpress().GridView(
    Grv => {
        Grv.Name = "GridSPDelivery";
        //Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD; PART_NO";
        Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD; RECEIVING_AREA";
        Grv.CallbackRouteValues = new { Controller = "SupplierPerformance", Action = "ReloadGridDeliveryDetail" };
        Grv.ClientSideEvents.BeginCallback = "OnBeginCallback";
        Grv.ClientSideEvents.EndCallback = "OnEndCallback";
        Grv.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        Grv.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.SettingsBehavior.AllowDragDrop = false;
        Grv.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
        //setting.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        Grv.SettingsEditing.Mode = GridViewEditingMode.Inline;

        Grv.SettingsPager.PageSizeItemSettings.Visible = true;
        Grv.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        Grv.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        Grv.CommandColumn.Visible = true;
        Grv.CommandColumn.ClearFilterButton.Visible = true;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.Width = Unit.Pixel(42);
        Grv.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(
                        chckBox =>
                        {
                            chckBox.Name = "ChkBoxDelivery";
                            chckBox.Properties.ClientSideEvents.CheckedChanged = "OnCheckAll";
                        }
                    ).Render();
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "ProductionMonth";
                col.Caption = "Production<br>Month";
                col.FieldName = "PROD_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SPMonthYear> pm = Model.GetModel<List<SPMonthYear>>();
                if (pm.Count() > 0)
                    pm.ForEach(s => cmdSuppCode.Items.Add(s.MonthYear));  
            });

        Grv.Columns.Add(
            col => {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SupplierICS> Supplier = Model.GetModel<List<SupplierICS>>();
                //modif by alira.agi 2015-04-09 combo box with grid
                if (Supplier.Count() > 0)
                    Supplier.ForEach(s => cmdSuppCode.Items.Add(s.SUPP_CD));
                // cmdSuppCode.DataSource = Supplier; 
                //cmdSuppCode.TextField = "SUPP_CD";
                //cmdSuppCode.TextFormatString = "{0}";
                //cmdSuppCode.ValueField = "SUPP_CD";
                //cmdSuppCode.Columns.Add("SUPP_CD", "SUPP CD", 100);
                //cmdSuppCode.Columns.Add("SUPP_NAME", "SUPP NAME", 100);
                // cmdSuppCode.ValueType = ...;
                
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });
        
        //Grv.Columns.Add(
        //    col =>
        //    {
        //        col.Name = "PartNo";
        //        col.Caption = "Part No";
        //        col.FieldName = "PART_NO";
        //        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        //        col.Width = Unit.Pixel(80);
        //    });

        //Grv.Columns.Add(
        //    col =>
        //    {
        //        col.Name = "PartName";
        //        col.Caption = "Part Name";
        //        col.FieldName = "PART_NAME";
        //        col.Width = Unit.Pixel(180);
        //    });
        
        Grv.Columns.Add(
            col => {
                col.Name = "QtySupplyMonth";
                col.Caption = "Supply<br>per Month";
                col.FieldName = "QTY_SUPPLY_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col => {
                col.Name = "QtyDelay";
                col.Caption = "Delay";
                col.FieldName = "QTY_DELAY";
                col.Width = Unit.Pixel(180);
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ReceivingArea";
                col.Caption = "Receiving<br>Area";
                col.FieldName = "RECEIVING_AREA";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                //col.PropertiesEdit.DisplayFormatString = "##,##";
                // add by alira.agi 2015-04-09
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdDock = col.PropertiesEdit as ComboBoxProperties;
                cmdDock.DropDownStyle = DropDownStyle.DropDown;
                List<DockPlant> DockPlants = Model.GetModel<List<DockPlant>>();
                cmdDock.DataSource = DockPlants;
                cmdDock.TextFormatString = "{0}";
                cmdDock.ValueField = "DockCode";
                cmdDock.Columns.Add("DockCode", "Dock Code", 100);
                cmdDock.Columns.Add("PlantName", "Plant Name", 100);
                //cmdDock.Columns.Add("SUPP_NAME", "SUPP NAME", 100);
                //if (DockPlants.Count() > 0)
                //    DockPlants.ForEach(s => cmdDock.Items.Add(s.DOCK_CODE));
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtyShortage";
                col.Caption = "Shortage";
                col.FieldName = "QTY_SHORTAGE";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtyIncorrect";
                col.Caption = "Incorrect";
                col.FieldName = "QTY_INCORRECT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });
                
        Grv.Columns.Add(
            col => {
                col.Name = "ProblemDesc";
                col.Caption = "Problem";
                col.FieldName = "PROBLEM_DESC";
                col.Width = Unit.Pixel(180);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedBy";
                col.Caption = "Created By";
                col.FieldName = "CREATED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedDate";
                col.Caption = "Created Date";
                col.FieldName = "CREATED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);

                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedBy";
                col.Caption = "ChangedBy";
                col.FieldName = "CHANGED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedDate";
                col.Caption = "Changed Date";
                col.FieldName = "CHANGED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);

                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });
        

        ///set value for call from javascript
        Grv.CustomJSProperties = (s, e) =>
        {
            MVCxGridView grid = (MVCxGridView)s;
            
            //Changed By FID.Reggy
            int StartIndex = 0;
            //int StartIndex = grid.PageIndex * grid.SettingsPager.PageSize;
            int EndIndex = Model.GetModel<List<SPDelivery>>() != null ? Model.GetModel<List<SPDelivery>>().Count :
                           Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);
            //int EndIndex = Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);

            object[] ProductionMonth = new object[EndIndex - StartIndex];
            object[] SupplierCode = new object[EndIndex - StartIndex];
            //object[] PartNo = new object[EndIndex - StartIndex];
            object[] SupplierMonth = new object[EndIndex - StartIndex];
            object[] Delay = new object[EndIndex - StartIndex];
            object[] ReceivingArea = new object[EndIndex - StartIndex];
            object[] Shortage = new object[EndIndex - StartIndex];
            object[] Incorrect = new object[EndIndex - StartIndex];
            object[] Problem = new object[EndIndex - StartIndex];

            for (int i = StartIndex; i < EndIndex; i++)
            {
                ProductionMonth[i - StartIndex] = grid.GetRowValues(i, "PROD_MONTH");
                SupplierCode[i - StartIndex] = grid.GetRowValues(i, "SUPPLIER_CD");
                //PartNo[i - StartIndex] = grid.GetRowValues(i, "PART_NO");
                SupplierMonth[i - StartIndex] = grid.GetRowValues(i, "QTY_SUPPLY_MONTH");
                Delay[i - StartIndex] = grid.GetRowValues(i, "QTY_DELAY");
                ReceivingArea[i - StartIndex] = grid.GetRowValues(i, "RECEIVING_AREA");
                Shortage[i - StartIndex] = grid.GetRowValues(i, "QTY_SHORTAGE");
                Incorrect[i - StartIndex] = grid.GetRowValues(i, "QTY_INCORRECT");
                Problem[i - StartIndex] = grid.GetRowValues(i, "PROBLEM_DESC");
                
            }

            e.Properties["cpProductionMonth"] = ProductionMonth;
            e.Properties["cpSupplierCode"] = SupplierCode;
            //e.Properties["cpPartNo"] = PartNo;
            e.Properties["cpSupplierMonth"] = SupplierMonth;
            e.Properties["cpDelay"] = Delay;
            e.Properties["cpReceivingArea"] = ReceivingArea;
            e.Properties["cpShortage"] = Shortage;
            e.Properties["cpIncorrect"] = Incorrect;
            e.Properties["cpProblem"] = Problem;
            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        };
        
        ///set gridview when button on clicked
        Grv.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            ///set visibility filter row
            if (IsEditRow == "1" || IsEditRow == "2")
            {
                gv.Settings.ShowFilterRow = false;
                gv.Settings.ShowFilterRowMenu = false;
            }
            else
            {
                gv.Settings.ShowFilterRow = true;
                gv.Settings.ShowFilterRowMenu = true;
            }

            ///Disable checkbox when grid is editing
            if (e.ButtonType == ColumnCommandButtonType.SelectCheckbox)
            {
                if (IsEditRow == "1" || IsEditRow == "2")
                    e.Enabled = false;
            }

            ///hide default button update and cancel on gridview when row is editing
            if (e.ButtonType == ColumnCommandButtonType.Update)
                e.Visible = false;

            if (e.ButtonType == ColumnCommandButtonType.Cancel)
                e.Visible = false;
        };

        ///disabled field when grid is editing
        Grv.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            if (e.Column.FieldName == "PROD_MONTH")
            {
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }

            if (e.Column.FieldName == "SUPPLIER_CD")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   

            if (e.Column.FieldName == "SUPPLIER_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            //if (e.Column.FieldName == "PART_NAME")
            //{
            //    e.Editor.Enabled = gv.IsNewRowEditing;
            //    e.Editor.Visible = !gv.IsNewRowEditing;
            //}
            
            if (e.Column.FieldName == "CREATED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
            // add by alira.agi 2015-05-28 ReceivingArea read only for edit
            if (e.Column.FieldName == "RECEIVING_AREA")
            {
                if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }
        };
    }).Bind(Model.GetModel<List<SPDelivery>>()).GetHtml()